// File Name : main.c
// Programmed by Jimmy Seo
// Program Date : Thu., April 2, 2004



#include <GC80C520_PL44I.H>
#include "hello.h"

xdata unsigned char *pcode;				    // for External Memory
data unsigned char temp1;		            // for Temporary Data
data unsigned char i;			           	// for Loop Parameters



// Prototype Functions
// 1. System Initialization
void initialize(void);

// 2. LCD Initialization
void initialize_lcd(void);

// 3. Clear LCD Screen
void clearscreen_lcd(void); 

// 4. LCD Address Setting
void address_lcd(unsigned char);

// 5. Print a Character on the LCD Screen
void print_char_lcd(unsigned char);

// 6. Print a String on the LCD Screen
void print_string_lcd(const char *);

// 7. Print a Sample Text
void HELLO(void);

// 8. msec fuction
void msec (int);

// 9. delay fuction
void delay_lcd (unsigned int);


// Main Function
//
void main(void) {

	delay_lcd(225);
	delay_lcd(225);
	delay_lcd(225);
	delay_lcd(225);
	delay_lcd(225);
	delay_lcd(225);
	delay_lcd(225);
	delay_lcd(225);

	initialize();

	initialize_lcd();

	clearscreen_lcd();


		
			
	HELLO();

	while(1);


} // End: void Main(void)


// Sub Function - 1. void initialize(void)
void initialize(void) {
	
                  
	PCON  = 0x00;		//  9,600 Baudrate (cf. SMOD_ = 1 (in AT89X52.h) )
	//PCON |= SMOD_;	// If you want 19,200 bps!! Insert this sentense...
	//PCON |= SMOD_;	// If you want 19,200 bps!! Insert this sentense...


	TH1   = 0xFD;   // 9,600 Baudrate

	SCON  = 0x50;   // Serial Comm. mode 1
	SBUF  = 0;
	  
	
	TL0   = 0x86;   // 11.0592M /12 = 0.9216us
	  

	pcode = 0x0000;


} // End: void initialize(void)


// Sub Function - 2. void initialize_lcd(void)
void initialize_lcd(void) {
	// pcode = 0xFFXX : PORTA (and Character LCD Display Databus)
	// pcode = 0xF9XX : LCD_CON[0] (LCD_RW)
	// pcode = 0xF8XX : LCD_CON[1] (LCD_EN)
	// pcode = 0xF7XX : LCD_CON[2] (LCD_RS)

	pcode =(unsigned char xdata *)0xF200;
	*(pcode) = 0x00;		// LCD_RW = 0;
	pcode = (unsigned char xdata *)0xF100;
	*(pcode) = 0x00;		// LCD_EN = 0;
	pcode = (unsigned char xdata *)0xF000;
	*(pcode) = 0x00;		// LCD_RS = 0;

	msec(50);


	pcode = (unsigned char xdata *)0xF300;
	*(pcode) = FUNCTION_SET2;
	pcode = (unsigned char xdata *)0xF100;
	*(pcode) = 0x01;		// LCD_EN = 1;
	*(pcode) = 0x00;		// LCD_EN = 0;


	delay_lcd(45);
	delay_lcd(45);


	pcode = (unsigned char xdata *)0xF300;
	*(pcode) = DISPLAY_ON1;
	pcode = (unsigned char xdata *)0xF100;
	*(pcode) = 0x01;		// LCD_EN = 1;
	*(pcode) = 0x00;		// LCD_EN = 0;

	
	delay_lcd(255);
	delay_lcd(225);


	pcode = (unsigned char xdata *)0xF300;
	*(pcode) = CLEAR_DISPLAY;
	pcode = (unsigned char xdata *)0xF100;
	*(pcode) = 0x01;		// LCD_EN = 1;
	*(pcode) = 0x00;		// LCD_EN = 0;

	
	delay_lcd(255);
	delay_lcd(225);


	pcode = (unsigned char xdata *)0xF300;
	*(pcode) = ENTRY_MODE1;
	pcode = (unsigned char xdata *)0xF100;
	*(pcode) = 0x01;		// LCD_EN = 1;
	*(pcode) = 0x00;		// LCD_EN = 0;


	delay_lcd(255);
	delay_lcd(225);
	


	pcode = (unsigned char xdata *)0xF000;
	*(pcode) = 0x01;		// LCD_RS = 1;
	
	msec(50);

} // End: void initialize_lcd(void)


// Sub Function - 3. void clearscreen_lcd(void)
void clearscreen_lcd(void) {
	// pcode = 0xFFXX : PORTA (and Character LCD Display Databus)
	// pcode = 0xF9XX : LCD_CON[0] (LCD_RW)
	// pcode = 0xF8XX : LCD_CON[1] (LCD_EN)
	// pcode = 0xF7XX : LCD_CON[2] (LCD_RS)

	pcode =(unsigned char xdata *)0xF000;
	*(pcode) = 0x00;		// LCD_RS = 0;

	pcode = (unsigned char xdata *)0xF300;
	*(pcode) = CLEAR_DISPLAY;
	pcode = (unsigned char xdata *)0xF100;
	*(pcode) = 0x01;		// LCD_EN = 1;
	*(pcode) = 0x00;		// LCD_EN = 0;

	pcode = (unsigned char xdata *)0xF000;
	*(pcode) = 0x01;		// LCD_RS = 1;

	
	delay_lcd(255);

	
} // End: void clearscreen_lcd(void)


// Sub Function - 4. void address_lcd(BYTE)
void address_lcd(unsigned char addr) {
	// pcode = 0xFFXX : PORTA (and Character LCD Display Databus)
	// pcode = 0xF9XX : LCD_CON[0] (LCD_RW)
	// pcode = 0xF8XX : LCD_CON[1] (LCD_EN)
	// pcode = 0xF7XX : LCD_CON[2] (LCD_RS)
	
	pcode = (unsigned char xdata *)0xF000;
	*(pcode) = 0x00;		// LCD_RS = 0;

	pcode = (unsigned char xdata *)0xF300;
	*(pcode) = addr;
	pcode = (unsigned char xdata *)0xF100;
	*(pcode) = 0x01;		// LCD_EN = 1;
	*(pcode) = 0x00;		// LCD_EN = 0;

	pcode = (unsigned char xdata *)0xF000;
	*(pcode) = 0x01;		// LCD_RS = 1;


	delay_lcd(255);

	

} // End: void address_lcd(BYTE addr) 


// Sub Function : 5. void print_char_lcd(BYTE)
void print_char_lcd(unsigned char c) {
	// pcode = 0xFFXX : PORTA (and Character LCD Display Databus)
	// pcode = 0xF9XX : LCD_CON[0] (LCD_RW)
	// pcode = 0xF8XX : LCD_CON[1] (LCD_EN)
	// pcode = 0xF7XX : LCD_CON[2] (LCD_RS)

	pcode = (unsigned char xdata *)0xF000;
	*(pcode) = 0x01;		// LCD_RS = 1;

	pcode = (unsigned char xdata *)0xF300;
	*(pcode) = c;
	pcode = (unsigned char xdata *)0xF100;
	*(pcode) = 0x01;		// LCD_EN = 1;
	*(pcode) = 0x00;		// LCD_EN = 0;

	pcode = (unsigned char xdata *)0xF000;
	*(pcode) = 0x00;		// LCD_RS = 0;

	
	delay_lcd(45);
	
	
} // End: void print_char_lcd(BYTE c)


// Sub Function : 6. void print_string_lcd(const char *)
void print_string_lcd(const char *s) {
	// pcode = 0xFFXX : PORTA (and Character LCD Display Databus)
	// pcode = 0xF9XX : LCD_CON[0] (LCD_RW)
	// pcode = 0xF8XX : LCD_CON[1] (LCD_EN)
	// pcode = 0xF7XX : LCD_CON[2] (LCD_RS)

	while (*s) {
		print_char_lcd(*s++);
	}

	delay_lcd(225);
	
} // End: void print_string_lcd(const char *s)


// Sub Function : 7. void HELLO(void)
void HELLO(void) {
	clearscreen_lcd();
	address_lcd(DDRAM_ADDR_ODD);
	print_string_lcd("  HELLO!  World");
	msec(100);

} // End: void HELLO(void)





/* delay function for m seconds */
void msec(int Delay)
{
	int i, j;
	for(j=0; j<Delay; j++)
		for (i=0; i<500; i++);
		
}

void sec(int Delay)
{
	int i, j;
	for(j=0; j<Delay; j++)
		for (i=0; i<500; i++);
		
}

void delay_lcd(unsigned int t) {
	unsigned char i;
	for(i=0; i<t; i++);
}
