// File Name : main.c
// Programmed by jimmy Seo
// Program Date : Tue. April 13, 2004
//

#include <GC80C520_PL44I.H>
#include "add.h"

// Declaration of the Variables
unsigned char xdata *pcode;	    // for External Memory
unsigned char temp;				// for Temporary Data
unsigned short lcd_data;
unsigned char j;			   // for Loop Parameters

unsigned char i;
unsigned short k,sum=0;

// Prototype Functions

// 1. LCD Initialization
void initialize_lcd(void);

// 2. Clear LCD Screen
void clearscreen_lcd(void); 

// 3. LCD Address Setting
void address_lcd(unsigned char);

// 4. Print a String on the LCD Screen
void print_string_lcd(const char *);

// 5. Integer display
void Print_INT (unsigned short *);

// 6. Display Character
void PutChar (unsigned char);

// 7. Display Character
void display (void);

// 8. msec
void msec (int);

// 9. delay lcd
void delay_lcd (unsigned int);

// 10. run
void run (unsigned char);


//Main Function
void main(void) {


	initialize_lcd();

	clearscreen_lcd();

	lcd_data = 0;
		
	display();

			
	run(DDRAM_ADDR_ODD);
		
	while(1);



} // End: void Main(void)



// Sub Function - 1. void initialize_lcd(void)
void initialize_lcd(void) {


	pcode = (unsigned char xdata *)0xF200;
	*(pcode) = 0x00;		// LCD_RW = 0;
	pcode = (unsigned char xdata *)0xF100;
	*(pcode) = 0x00;		// LCD_EN = 0;
	pcode = (unsigned char xdata *)0xF000;
	*(pcode) = 0x00;		// LCD_RS = 0;

	msec(15);
	msec(15);
	msec(15);


	pcode = (unsigned char xdata *)0xF300;
	*(pcode) = FUNCTION_SET2;
	pcode = (unsigned char xdata *)0xF100;
	*(pcode) = 0x01;		// LCD_EN = 1;
	*(pcode) = 0x00;		// LCD_EN = 0;

	msec(5);
	msec(5);
	msec(5);
	
	pcode = (unsigned char xdata *)0xF300;
	*(pcode) = FUNCTION_SET2;
	pcode = (unsigned char xdata *)0xF100;
	*(pcode) = 0x01;		// LCD_EN = 1;
	*(pcode) = 0x00;		// LCD_EN = 0;

	msec(2);
	msec(2);
	msec(2);
	
	pcode = (unsigned char xdata *)0xF300;
	*(pcode) = FUNCTION_SET2;
	pcode = (unsigned char xdata *)0xF100;
	*(pcode) = 0x01;		// LCD_EN = 1;
	*(pcode) = 0x00;		// LCD_EN = 0;

	msec(1);
	msec(1);
	msec(1);
	
	pcode = (unsigned char xdata *)0xF300;
	*(pcode) = FUNCTION_SET2;
	pcode = (unsigned char xdata *)0xF100;
	*(pcode) = 0x01;		// LCD_EN = 1;
	*(pcode) = 0x00;		// LCD_EN = 0;

	delay_lcd(45);
	delay_lcd(45);
	delay_lcd(45);


	pcode = (unsigned char xdata *)0xF300;
	*(pcode) = DISPLAY_ON1;
	pcode = (unsigned char xdata *)0xF100;
	*(pcode) = 0x01;		// LCD_EN = 1;
	*(pcode) = 0x00;		// LCD_EN = 0;

	delay_lcd(255);
	delay_lcd(255);
	delay_lcd(255);


	pcode = (unsigned char xdata *)0xF300;
	*(pcode) = CLEAR_DISPLAY;
	pcode = (unsigned char xdata *)0xF100;
	*(pcode) = 0x01;		// LCD_EN = 1;
	*(pcode) = 0x00;		// LCD_EN = 0;

	delay_lcd(255);
	delay_lcd(255);
	delay_lcd(255);


	pcode = (unsigned char xdata *)0xF300;
	*(pcode) = ENTRY_MODE1;
	pcode = (unsigned char xdata *)0xF100;
	*(pcode) = 0x01;		// LCD_EN = 1;
	*(pcode) = 0x00;		// LCD_EN = 0;

	delay_lcd(255);
	delay_lcd(255);
	delay_lcd(255);


	pcode = (unsigned char xdata *)0xF000;
	*(pcode) = 0x01;		// LCD_RS = 1;
	
	msec(1);
	msec(1);
	msec(1);

} // End: void initialize_lcd(void)

// Sub Function - 2. void clearscreen_lcd(void)
void clearscreen_lcd(void) {
	// pcode = 0xFFXX : PORTA (and Character LCD Display Databus)
	// pcode = 0xF9XX : LCD_CON[0] (LCD_RW)
	// pcode = 0xF8XX : LCD_CON[1] (LCD_EN)
	// pcode = 0xF7XX : LCD_CON[2] (LCD_RS)

	pcode = (unsigned char xdata *)0xF000;
	*(pcode) = 0x00;		// LCD_RS = 0;

	pcode = (unsigned char xdata *)0xF300;
	*(pcode) = CLEAR_DISPLAY;
	
	pcode = (unsigned char xdata *)0xF100;
	*(pcode) = 0x01;		// LCD_EN = 1;
	*(pcode) = 0x00;		// LCD_EN = 0;

	pcode = (unsigned char xdata *)0xF000;
	*(pcode) = 0x01;		// LCD_RS = 1;

	delay_lcd(255);
	delay_lcd(255);
	delay_lcd(255);
} // End: void clearscreen_lcd(void)

// Sub Function - 3. void address_lcd(BYTE)
void address_lcd(unsigned char addr) {
	// pcode = 0xFFXX : PORTA (and Character LCD Display Databus)
	// pcode = 0xF9XX : LCD_CON[0] (LCD_RW)
	// pcode = 0xF8XX : LCD_CON[1] (LCD_EN)
	// pcode = 0xF7XX : LCD_CON[2] (LCD_RS)
	
	pcode = (unsigned char xdata *)0xF000;
	*(pcode) = 0x00;		// LCD_RS = 0;

	pcode = (unsigned char xdata *)0xF300;
	*(pcode) = addr;

	pcode = (unsigned char xdata *)0xF100;
	*(pcode) = 0x01;		// LCD_EN = 1;
	*(pcode) = 0x00;		// LCD_EN = 0;

	pcode = (unsigned char xdata *)0xF000;
	*(pcode) = 0x01;		// LCD_RS = 1;

	delay_lcd(255);
	delay_lcd(255);
	delay_lcd(255);

} // End: void address_lcd(unsigned char addr) 

// Sub Function : 4. void print_string_lcd(const char *)
void print_string_lcd(const char *s) {
	// pcode = 0xFFXX : PORTA (and Character LCD Display Databus)
	// pcode = 0xF9XX : LCD_CON[0] (LCD_RW)
	// pcode = 0xF8XX : LCD_CON[1] (LCD_EN)
	// pcode = 0xF7XX : LCD_CON[2] (LCD_RS)

	pcode = (unsigned char xdata *)0xF000;
	*(pcode) = 0x01;		// LCD_RS = 1;

	while (*s) {
	pcode = (unsigned char xdata *)0xF300;
	*(pcode) = *(s++);

	pcode = (unsigned char xdata *)0xF100;
	*(pcode) = 0x01;		// LCD_EN = 1;
	*(pcode) = 0x00;		// LCD_EN = 0;

	delay_lcd(45);
	delay_lcd(45);
	delay_lcd(45);
	delay_lcd(45);
	}

	pcode = (unsigned char xdata *)0xF000;
	*(pcode) = 0x00;		// LCD_RS = 0;

	delay_lcd(225);
	delay_lcd(225);
	delay_lcd(225);
} // End: void print_string_lcd(const char *s)

// Sub Function : 5.  void Print_INT(unsigned short*) {
/* Function to output the decimal value of the count on the LCD */
void Print_INT(unsigned short* d) {

	unsigned char hund,ten,one;
	unsigned char poly, temp;
	unsigned short value;

	value = *d;
	hund = value/100;
	ten = (value-hund*100)/10;
	one = (value-hund*100-ten*10);

	for (poly = 0; poly < 3; poly++) {
		if (poly == 0) temp = hund;
		else if (poly == 1) temp = ten;
		else temp = one;
		switch (temp) {
			case 0 : PutChar('0'); break;
			case 1 : PutChar('1'); break;
			case 2 : PutChar('2'); break;
			case 3 : PutChar('3'); break;
			case 4 : PutChar('4'); break;
			case 5 : PutChar('5'); break;
			case 6 : PutChar('6'); break;
			case 7 : PutChar('7'); break;
			case 8 : PutChar('8'); break;
			case 9 : PutChar('9'); break;
		}
	}

}

// Sub Function : 6.  void PutChar(unsigned char) {
void PutChar(unsigned char c) {
	pcode = (unsigned char xdata *)0xF000;
	*(pcode) = 0x01;		// LCD_RS = 1;

	pcode = (unsigned char xdata *)0xF300;
	*(pcode) = c;
	
	pcode = (unsigned char xdata *)0xF100;
	*(pcode) = 0x01;		// LCD_EN = 1;
	*(pcode) = 0x00;		// LCD_EN = 0;
	pcode = (unsigned char xdata *)0xF000;
	*(pcode) = 0x00;		// LCD_RS = 0;
	delay_lcd(45);
	delay_lcd(45);
	delay_lcd(45);
	delay_lcd(45);
}

// Sub Function : 7.  void adc_display(void) {
void display (void) {
		address_lcd(DDRAM_ADDR_EVEN);
		print_string_lcd("**Test Result!**");
		address_lcd(DDRAM_ADDR_ODD + 0x00);
		print_string_lcd("       = i     *       = SUM   *");

}
	
// Sub Function : 8.  void msec(int) {
/* delay function for m seconds */
void msec(int Delay)
{
	int i, j;
	for(j=0; j<Delay; j++)
		for (i=0; i<100; i++);
}

// Sub Function : 9.  void delay_lcd(unsigned int) {
void delay_lcd(unsigned int t) {

//	unsigned int i;
	for(i=0; i<t; i++);
}

// Sub Function : 10.  void run(unsigned char) {
void run(unsigned char addr) {

//	unsigned short k,sum=0;
		
	for(k=0; k <= 10; k++){
			sum += k;
		
	address_lcd(addr);
	
	Print_INT(&k);
	msec(150);
	msec(150);
	msec(150);
	msec(150);
	
	address_lcd(addr + 0x10);
	
	Print_INT(&sum);
	msec(150);
	msec(150);
	msec(150);
	msec(150);	
	}

}
