// File Name : main.c
// Programmed by Jimmy Seo
// Program Date : Mon., May 10, 2004
//
#include <GC80C520_PL44I.H>
#include "timer.h"

// Declaration of the Variables
xdata unsigned char *pcode;				  // for External Memory
data unsigned char  temp1;				  // for Temporary Data
data unsigned char  temp;				  
data unsigned char  i;					  // for Loop Parameters
data unsigned char  p;					  // for Loop Parameters
data unsigned char	port_change;		  // for PORT Display Delection
data unsigned char	port_value_change;	  // for PORT Value Update Change
data unsigned char	port_display_change;  // for PORT Display Selection

unsigned int	loop_cnt;			// for Loop Parameter    @ timer0
unsigned char	display_count;		// for Display Parameter @timer0


// Prototype Functions
// 1. System Initialization
void initialize(void);

// 2. Led Output
//void output_led(void);

// 3. delay fuction
//void delay (int);


// Main Function
//
void main(void) {

	initialize();

	
	loop_cnt = 0;

	TR0 = 1;	// Timer0 Start (Enable)

	
	while(1){
		temp = 0;
	}

	
} // End: void Main(void)



// Sub Function - 1. void initialize(void)
void initialize(void) {
	TMOD  = 0x22; 	// Timer 0/1 : Mode 2<Auto Reload>
					
    
	TH0   = 0x06;   // TH0 for Auto-reload
					// (Fosc/12)^-1*(256-TH0) = Timing Duty
					// When Fosc = 12MHz and TH0 = 0x06,
					// Timing Duty is 0.25msec (250 usec)
		
	pcode = (unsigned char xdata *)0x0000;

	ET0 = 1;		// Timer 0 Interrupt Enable
	EA =  1;		// All Interrupts Enable
	
	display_count = 0;
	loop_cnt = 0;

} // End: void initialize(void)


/*
// LED Display
void output_led(void){
	
	pcode = (unsigned char xdata *)0xFD00;
	
	temp1 =0x01;

	for (p=0; p<8; p++) {
		delay(30);				
		temp1 = (temp1<<1);
		*(pcode) = temp1;
	}

	temp1 = 0x80;

	for (p=0; p<8; p++) {
		delay(30);				
		temp1 = (temp1>>1);
		*(pcode) = temp1;
	} // End: for (p=0; p<8; p++)
	
			
}




// delay function for m seconds
void delay(int Delay)
{
	int i, j;
	for(j=0; j<Delay; j++)
		for (i=0; i<100; i++);
}
*/



// Sub Function : Timer 0 Interrupt
void timer0_int(void) interrupt TF0_VECTOR {
	
	
	// 7-segment Display	
	if (loop_cnt == 2000) {	 // 2000 : 0.5sec

		loop_cnt = 0;
		
		switch (display_count) {
			case 0 :
				pcode = (unsigned char xdata *) 0xF600;		// Port B (7-segment Display)
				*(pcode) = D0;		// Refer to timer.h file about MACRO "D0".
				display_count++;
				break;
			case 1 :
				pcode = (unsigned char xdata *) 0xF600;		// Port B (7-segment Display)
				*(pcode) = D1;		// Refer to timer.h file about MACRO "D0".
				display_count++;
				break;
			case 2 :
				pcode = (unsigned char xdata *) 0xF600;		// Port B (7-segment Display)
				*(pcode) = D2;		// Refer to timer.h file about MACRO "D0".
				display_count++;
				break;
			case 3 :
				pcode = (unsigned char xdata *) 0xF600;		// Port B (7-segment Display)
				*(pcode) = D3;		// Refer to timer.h file about MACRO "D0".
				display_count++;
				break;
			case 4 :
				pcode = (unsigned char xdata *) 0xF600;		// Port B (7-segment Display)
				*(pcode) = D4;		// Refer to timer.h file about MACRO "D0".
				display_count++;
				break;
			case 5 :
				pcode = (unsigned char xdata *) 0xF600;		// Port B (7-segment Display)
				*(pcode) = D5;		// Refer to timer.h file about MACRO "D0".
				display_count++;
				break;
			case 6 :
				pcode = (unsigned char xdata *) 0xF600;		// Port B (7-segment Display)
				*(pcode) = D6;		// Refer to timer.h file about MACRO "D0".
				display_count++;
				break;
			case 7 :
				pcode = (unsigned char xdata *) 0xF600;		// Port B (7-segment Display)
				*(pcode) = D7;		// Refer to timer.h file about MACRO "D0".
				display_count++;
				break;
			case 8 :
				pcode = (unsigned char xdata *) 0xF600;		// Port B (7-segment Display)
				*(pcode) = D8;		// Refer to timer.h file about MACRO "D0".
				display_count++;
				break;
			case 9 :
				pcode = (unsigned char xdata *) 0xF600;		// Port B (7-segment Display)
				*(pcode) = D9;		// Refer to timer.h file about MACRO "D0".
				display_count = 0;
				break;
			
		}
		
	}
	
	loop_cnt++;
	TF0 = 0;					 // Timer 0 Overflow Falg Clear

} // End : Sub Function - void timer0_int(void) interrupt TF0_VECTOR
