// File Name : main.c
// Programmed by Hyun Jee
// Program Date : Mon., Jan. 10, 2005
//
#include <GC80C520_PL44I.H>
#include "timer.h"

// Declaration of the Variables
xdata unsigned char *pcode;				  // for External Memory
data unsigned char  temp1;				  // for Temporary Data
data unsigned char  temp;				  
data unsigned char  i;					  // for Loop Parameters
data unsigned char  p;					  // for Loop Parameters
data unsigned char	port_change;		  // for PORT Display Delection
data unsigned char	port_value_change;	  // for PORT Value Update Change
data unsigned char	port_display_change;  // for PORT Display Selection

unsigned int	loop_cnt;			// for Loop Parameter    @ timer0


// Prototype Functions
// 1. System Initialization
void initialize(void);



// Main Function
//
void main(void) {

	initialize();

	
	loop_cnt = 0;

	TR0 = 1;	// Timer0 Start (Enable)

	
	while(1){
		temp = 0;
	}

	
} // End: void Main(void)



// Sub Function - 1. void initialize(void)
void initialize(void) {
	
	
	//-------------------------------------------------
	TMOD  = 0x22; 	// Timer 0/1 : Mode 2<Auto Reload>
					
    
	TH0   = 0x06;   // TH0 for Auto-reload
					// (Fosc/12)^-1*(256-TH0) = Timing Duty
					// When Fosc = 12MHz and TH0 = 0x06,
					// Timing Duty is 0.25msec (250 usec)
		
	pcode = (unsigned char xdata *)0x0000;

	ET0 = 1;		// Timer 0 Interrupt Enable
	
	
	//-------------------------------------------------
	ADCSEL |= 0x08;		// ADC Channel Port Selection : P1.3
	
	ADCON |= AD_EN_;		// ADC Enable (AD_EN_ or 0x80)
	
	ADCON |= 0x0C;		// ADC Channel Analog MUX Selection : P1.3
	
	EADC = 1;			// ADC Interrupt Enable	
	
	
	//-------------------------------------------------
	EA =  1;			// All Interrupts Enable
	
	loop_cnt = 0;

} // End: void initialize(void)


// Sub Function : Timer 0 Interrupt
void timer0_int(void) interrupt TF0_VECTOR {
	
	
	// 7-segment Display	
	if (loop_cnt == 2000) {	 // 2000 : 0.5sec

		loop_cnt = 0;
		
		
		ADCON |= AD_REQ_;		// ADC Run/Start (AD_REQ_ or 0x40)
		
	}
	
	loop_cnt++;
	TF0 = 0;					 // Timer 0 Overflow Falg Clear

} // End : Sub Function - void timer0_int(void) interrupt TF0_VECTOR



// Sub Function : ADC Interrupt
void adc_int(void) interrupt ADC_VECTOR {
	
	pcode = (unsigned char xdata *)0xF500;		// Port C (LED Display)
	*(pcode) = ADCR;							// ADC Result (Upper 8 bits)
	
												// ADC Result (9 bits) = ADCR (upper 8 bits), ADCON.0(1 bit)
												
	ADCON &= 0xEF;				// ADC Interrupt Falg (ADCF) Clear
		
}


