// File Name : main.c
// Programmed by Young Jeon
// Program Date : Wed., May 14, 2003
//
#include <GC80C520_PL44I.h>
#include "adc.h"

// Declaration of the Variables
unsigned char xdata *pcode;	// for External Memory
unsigned char temp, temp1;				// for Temporary Data
unsigned char adc_intr;
//unsigned char lcd_data_high;
//unsigned char lcd_data_low;
unsigned int lcd_data;
unsigned char adcon_tmp;
unsigned char adcon_tmp2;
unsigned char adcsel_div;
unsigned char adcsel_port;
unsigned char j;				// for Loop Parameters
unsigned int adc_value;
unsigned char hund,ten,one;
unsigned char poly;
unsigned char ch, addr;

// Prototype Functions

// 1. LCD Initialization
void initialize_lcd(void);

// 2. Clear LCD Screen
void clearscreen_lcd(void); 

// 3. LCD Address Setting
void address_lcd(BYTE);

// 4. Print a Character on the LCD Screen
void print_char_lcd(BYTE);

// 5. Print a String on the LCD Screen
void print_string_lcd(const char *);

// 6. Integer display
void Print_INT (unsigned short *);

// 7. msec
void msec (unsigned int);

// 8. delay lcd
void delay_lcd (unsigned int);

// 9. Display Character
void PutChar (unsigned char);

// 10. Display Character
void adc_display (void);

// 11. ADC clock selection
void adc_clock_sel (void);

// 12. ADC run
void adc_run (BYTE, BYTE);


// Main Function
//
void main(void) {



	initialize_lcd();

	clearscreen_lcd();

	EA = 1;
	EADC = 1;
	adc_intr = 0;
	lcd_data = 0;
	adcon_tmp = 0;
	adcon_tmp2 = 0;
	adcsel_div = 0x00;
	adcsel_port = 0x0e;
	p1sel = 0x0e;
//	pmr = 0x04;

	adc_display();

	while(1) {
		/************************************************************/
		// Description for Address Mapping
		//
		// pcode = 0xFFXX : PORTA (and Character LCD Display Databus)
		// pcode = 0xFEXX : PORTB (and 7-segment Display)
		// pcode = 0xFDXX : PORTC (and 8 bits LED Display)
		// pcode = 0xF9XX : LCD_CON[0] (LCD_RW)
		// pcode = 0xF8XX : LCD_CON[1] (LCD_EN)
		// pcode = 0xF7XX : LCD_CON[2] (LCD_RS)
		/************************************************************/
		
		adc_clock_sel();
		adcsel = adcsel_div | adcsel_port;

		// ADC channel 1 selection
		//adc_run(0x04, DDRAM_ADDR_ODD);
		adcr = 0x55;
		j = adcr;
		ch = 0x04; addr = DDRAM_ADDR_ODD;
		adcon = ch;		// ADC channel 1
		j = adcon;
		j = j & 0xdf;
		while (j != ch) { pcode = (unsigned char xdata *)0xf500; *pcode = 0x01; }
	
		msec(150);
		adcon = 0xc0 | ch;		// ADC start
		while (!adc_intr);
		adcon_tmp2 = adcon_tmp & 0x01;
		lcd_data = lcd_data * 2;
		lcd_data = lcd_data + adcon_tmp2;
		adcon = 0x00;		// ADC clear
		address_lcd(addr);
		Print_INT(&lcd_data);
		adc_intr = 0;
		msec(150);
	
			// ADC channel 2 selection
		//adc_run(0x08, DDRAM_ADDR_EVEN+0x10);
		ch = 0x08; addr = DDRAM_ADDR_EVEN+0x10;
		adcon = ch;		// ADC channel 1
		j = adcon;
		j = j & 0xdf;
		while (j != ch) { pcode = (unsigned char xdata *)0xf500; *pcode = 0x01; }
	
		msec(150);
		adcon = 0xc0 | ch;		// ADC start
		while (!adc_intr);
		adcon_tmp2 = adcon_tmp & 0x01;
		lcd_data = lcd_data * 2;
		lcd_data = lcd_data + adcon_tmp2;
		adcon = 0x00;		// ADC clear
		address_lcd(addr);
		Print_INT(&lcd_data);
		adc_intr = 0;
		msec(150);
			
			// ADC channel 3 selection
		//adc_run(0x0c, DDRAM_ADDR_ODD+0x10);
		ch = 0x0c; addr = DDRAM_ADDR_ODD+0x10;
		adcon = ch;		// ADC channel 1
		j = adcon;
		j = j & 0xdf;
		while (j != ch) { pcode = (unsigned char xdata *)0xf500; *pcode = 0x01; }
	
		msec(150);
		adcon = 0xc0 | ch;		// ADC start
		while (!adc_intr);
		adcon_tmp2 = adcon_tmp & 0x01;
		lcd_data = lcd_data * 2;
		lcd_data = lcd_data + adcon_tmp2;
		adcon = 0x00;		// ADC clear
		address_lcd(addr);
		Print_INT(&lcd_data);
		adc_intr = 0;
		msec(150);

	} // End: while(1)

	//while (1);

} // End: void Main(void)


// Sub Function - 2. void initialize_lcd(void)
void initialize_lcd(void) {
	// pcode = 0xFFXX : PORTA (and Character LCD Display Databus)
	// pcode = 0xF9XX : LCD_CON[0] (LCD_RW)
	// pcode = 0xF8XX : LCD_CON[1] (LCD_EN)
	// pcode = 0xF7XX : LCD_CON[2] (LCD_RS)

	pcode = (unsigned char xdata *)0xF200;
	*(pcode) = 0x00;		// LCD_RW = 0;
	pcode = (unsigned char xdata *)0xF100;
	*(pcode) = 0x00;		// LCD_EN = 0;
	pcode = (unsigned char xdata *)0xF000;
	*(pcode) = 0x00;		// LCD_RS = 0;

	msec(15);
	msec(15);
	msec(15);


	pcode = (unsigned char xdata *)0xF300;
	*(pcode) = FUNCTION_SET2;
	pcode = (unsigned char xdata *)0xF100;
	*(pcode) = 0x01;		// LCD_EN = 1;
	*(pcode) = 0x00;		// LCD_EN = 0;

	msec(5);
	msec(5);
	msec(5);
	
	pcode = (unsigned char xdata *)0xF300;
	*(pcode) = FUNCTION_SET2;
	pcode = (unsigned char xdata *)0xF100;
	*(pcode) = 0x01;		// LCD_EN = 1;
	*(pcode) = 0x00;		// LCD_EN = 0;

	msec(2);
	msec(2);
	msec(2);
	
	pcode = (unsigned char xdata *)0xF300;
	*(pcode) = FUNCTION_SET2;
	pcode = (unsigned char xdata *)0xF100;
	*(pcode) = 0x01;		// LCD_EN = 1;
	*(pcode) = 0x00;		// LCD_EN = 0;

	msec(1);
	msec(1);
	msec(1);
	
	pcode = (unsigned char xdata *)0xF300;
	*(pcode) = FUNCTION_SET2;
	pcode = (unsigned char xdata *)0xF100;
	*(pcode) = 0x01;		// LCD_EN = 1;
	*(pcode) = 0x00;		// LCD_EN = 0;

	delay_lcd(45);
	delay_lcd(45);
	delay_lcd(45);


	pcode = (unsigned char xdata *)0xF300;
	*(pcode) = DISPLAY_ON1;
	pcode = (unsigned char xdata *)0xF100;
	*(pcode) = 0x01;		// LCD_EN = 1;
	*(pcode) = 0x00;		// LCD_EN = 0;

	delay_lcd(255);
	delay_lcd(255);
	delay_lcd(255);


	pcode = (unsigned char xdata *)0xF300;
	*(pcode) = CLEAR_DISPLAY;
	pcode = (unsigned char xdata *)0xF100;
	*(pcode) = 0x01;		// LCD_EN = 1;
	*(pcode) = 0x00;		// LCD_EN = 0;

	delay_lcd(255);
	delay_lcd(255);
	delay_lcd(255);


	pcode = (unsigned char xdata *)0xF300;
	*(pcode) = ENTRY_MODE1;
	pcode = (unsigned char xdata *)0xF100;
	*(pcode) = 0x01;		// LCD_EN = 1;
	*(pcode) = 0x00;		// LCD_EN = 0;

	delay_lcd(255);
	delay_lcd(255);
	delay_lcd(255);


	pcode = (unsigned char xdata *)0xF000;
	*(pcode) = 0x01;		// LCD_RS = 1;
	
	msec(1);
	msec(1);
	msec(1);

} // End: void initialize_lcd(void)


// Sub Function - 3. void clearscreen_lcd(void)
void clearscreen_lcd(void) {
	// pcode = 0xFFXX : PORTA (and Character LCD Display Databus)
	// pcode = 0xF9XX : LCD_CON[0] (LCD_RW)
	// pcode = 0xF8XX : LCD_CON[1] (LCD_EN)
	// pcode = 0xF7XX : LCD_CON[2] (LCD_RS)

	pcode = (unsigned char xdata *)0xF000;
	*(pcode) = 0x00;		// LCD_RS = 0;

	pcode = (unsigned char xdata *)0xF300;
	*(pcode) = CLEAR_DISPLAY;
	pcode = (unsigned char xdata *)0xF100;
	*(pcode) = 0x01;		// LCD_EN = 1;
	*(pcode) = 0x00;		// LCD_EN = 0;

	pcode = (unsigned char xdata *)0xF000;
	*(pcode) = 0x01;		// LCD_RS = 1;

	delay_lcd(255);
	delay_lcd(255);
	delay_lcd(255);
} // End: void clearscreen_lcd(void)


// Sub Function - 4. void address_lcd(BYTE)
void address_lcd(BYTE addr) {
	// pcode = 0xFFXX : PORTA (and Character LCD Display Databus)
	// pcode = 0xF9XX : LCD_CON[0] (LCD_RW)
	// pcode = 0xF8XX : LCD_CON[1] (LCD_EN)
	// pcode = 0xF7XX : LCD_CON[2] (LCD_RS)
	
	pcode = (unsigned char xdata *)0xF000;
	*(pcode) = 0x00;		// LCD_RS = 0;

	pcode = (unsigned char xdata *)0xF300;
	*(pcode) = addr;
	pcode = (unsigned char xdata *)0xF100;
	*(pcode) = 0x01;		// LCD_EN = 1;
	*(pcode) = 0x00;		// LCD_EN = 0;

	pcode = (unsigned char xdata *)0xF000;
	*(pcode) = 0x01;		// LCD_RS = 1;

	delay_lcd(255);
	delay_lcd(255);
	delay_lcd(255);

} // End: void address_lcd(BYTE addr) 


// Sub Function : 5. void print_char_lcd(BYTE)
void print_char_lcd(BYTE c) {
	// pcode = 0xFFXX : PORTA (and Character LCD Display Databus)
	// pcode = 0xF9XX : LCD_CON[0] (LCD_RW)
	// pcode = 0xF8XX : LCD_CON[1] (LCD_EN)
	// pcode = 0xF7XX : LCD_CON[2] (LCD_RS)

	pcode = (unsigned char xdata *)0xF000;
	*(pcode) = 0x01;		// LCD_RS = 1;

	pcode = (unsigned char xdata *)0xF300;
	*(pcode) = c;
	pcode = (unsigned char xdata *)0xF100;
	*(pcode) = 0x01;		// LCD_EN = 1;
	*(pcode) = 0x00;		// LCD_EN = 0;

	pcode = (unsigned char xdata *)0xF000;
	*(pcode) = 0x00;		// LCD_RS = 0;

	delay_lcd(45);
	delay_lcd(45);
	delay_lcd(45);
	delay_lcd(45);
} // End: void print_char_lcd(BYTE c)


// Sub Function : 6. void print_string_lcd(const char *)
void print_string_lcd(const char *s) {
	// pcode = 0xFFXX : PORTA (and Character LCD Display Databus)
	// pcode = 0xF9XX : LCD_CON[0] (LCD_RW)
	// pcode = 0xF8XX : LCD_CON[1] (LCD_EN)
	// pcode = 0xF7XX : LCD_CON[2] (LCD_RS)

	unsigned char c;
	int i;

	for (i=0; i<32; i++) {
//	while (*s) {
		c = *s++;
		print_char_lcd(c);
	}

	delay_lcd(225);
	delay_lcd(225);
	delay_lcd(225);
	delay_lcd(225);
} // End: void print_string_lcd(const char *s)

/* Function to output the decimal value of the count on the LCD */
void Print_INT(unsigned short* d) {
//	unsigned char hund,ten,one;
//	unsigned char poly, temp;
//	unsigned short adc_value;

	adc_value = *d;

	hund = adc_value/100;
	ten = (adc_value-hund*100)/10;
	one = (adc_value-hund*100-ten*10);

	for (poly = 0; poly < 3; poly++) {
		if (poly == 0) temp = hund;
		else if (poly == 1) temp = ten;
		else temp = one;
		switch (temp) {
			case 0 : PutChar('0'); break;
			case 1 : PutChar('1'); break;
			case 2 : PutChar('2'); break;
			case 3 : PutChar('3'); break;
			case 4 : PutChar('4'); break;
			case 5 : PutChar('5'); break;
			case 6 : PutChar('6'); break;
			case 7 : PutChar('7'); break;
			case 8 : PutChar('8'); break;
			case 9 : PutChar('9'); break;
		}
	}
}

void PutChar(unsigned char c) {
	//RS=1;
	pcode = (unsigned char xdata *)0xF000;
	*(pcode) = 0x01;		// LCD_RS = 1;

	//LCD_BUS = c;
	pcode = (unsigned char xdata *)0xF300;
	*(pcode) = c;
  //EnableLCD();
	pcode = (unsigned char xdata *)0xF100;
	*(pcode) = 0x01;		// LCD_EN = 1;
	*(pcode) = 0x00;		// LCD_EN = 0;
	//RS=0;
	pcode = (unsigned char xdata *)0xF000;
	*(pcode) = 0x00;		// LCD_RS = 0;
	delay_lcd(45);
	delay_lcd(45);
	delay_lcd(45);
	delay_lcd(45);
}

void adc_display (void) {
	address_lcd(DDRAM_ADDR_EVEN + 0x00);
	print_string_lcd("     = ADC_CH0 *     = ADC_CH2 *");
	address_lcd(DDRAM_ADDR_ODD + 0x00);
	print_string_lcd("     = ADC_CH1 *     = ADC_CH3 *");
}

/* delay function for m seconds */
void msec(unsigned int Delay)
{
	unsigned int i, j;
	for(j=0; j<Delay; j++)
		for (i=0; i<500; i++);	// before Gentos V2.2 (Original Code)
		//for (i=0; i<80; i++);		// Gentos V2.2
}

void delay_lcd(unsigned int t) {
	unsigned int i;
	for(i=0; i<t; i++);
}

void adc_clock_sel(void) {
	if (!P3_1) {
		adcsel_div = 0x00;
		pcode = (unsigned char xdata *)0xf500;
		*pcode = adcsel_div;
	}
	else if (!P3_2) {
		adcsel_div = 0x20;
		pcode = (unsigned char xdata *)0xf500;
		*pcode = adcsel_div;
	}
	else if (!P3_3) {
		adcsel_div = 0x40;
		pcode = (unsigned char xdata *)0xf500;
		*pcode = adcsel_div;
	}
	else if (!P3_4) {
		adcsel_div = 0x60;
		pcode = (unsigned char xdata *)0xf500;
		*pcode = adcsel_div;
	}
	else if (!P3_5) {
		adcsel_div = 0x80;
		pcode = (unsigned char xdata *)0xf500;
		*pcode = adcsel_div;
	}
}	

/*
void adc_run (BYTE ch, BYTE addr) {
	adcon = ch;		// ADC channel 1
	j = adcon;
	j = j & 0xdf;
	while (j != ch) {
		pcode = (unsigned char xdata *)0xfd00;
		*pcode = 0x01;
	}

	msec(150);
	adcon = 0xc0 | ch;		// ADC start
	
	
	while (!adc_intr);
	adcon_tmp2 = adcon_tmp & 0x01;
	lcd_data = lcd_data * 2;
	lcd_data = lcd_data + adcon_tmp2;
	adcon = 0x00;		// ADC clear
	address_lcd(addr);
	Print_INT(&lcd_data);
	adc_intr = 0;
	msec(150);
}
*/

void adc_isr (void) interrupt ADC_VECTOR {
	lcd_data = adcr;
	temp = adcon_tmp & 0xef;
	adcon &= 0xEF;		// ADC Interrupt Falg (ADCF) Clear
	adc_intr = 1;
}
