// File Name : main.c
// Programmed by Hyun Jee
// Program Date : Mon., Jan. 10, 2005
//
#include <GC80C520_PL44I.H>
#include "timer.h"

// Declaration of the Variables
xdata unsigned char *pcode;				  // for External Memory
data unsigned char  temp1;				  // for Temporary Data
data unsigned char  temp;				  
data unsigned char  i;					  // for Loop Parameters
data unsigned char  p;					  // for Loop Parameters
data unsigned char	port_change;		  // for PORT Display Delection
data unsigned char	port_value_change;	  // for PORT Value Update Change
data unsigned char	port_display_change;  // for PORT Display Selection

unsigned int	loop_cnt;			// for Loop Parameter    @ timer0
unsigned char	received_data;

unsigned char	hund;
unsigned char	ten;
unsigned char	one;

unsigned int	adc_result;



// Prototype Functions
// 1. System Initialization
void initialize(void);

// Main Function
//
void main(void) {

	initialize();

	
	loop_cnt = 0;

	TR1 = 1;	// Timer1 Start (Enable) for UART Communication
	TR0 = 1;	// Timer0 Start (Enable) 

	
	while(1){
		temp = 0;
	}
	
} // End: void Main(void)

// Sub Function - 1. void initialize(void)
void initialize(void) {

	//-------------------------------------------------
	TMOD  = 0x22; 	// Timer 0/1 : Mode 2<Auto Reload>
					
    
	TH0   = 0x78;   // TH0 for Auto-reload
					// (Fosc/11.0592MHz)^-1*(256-TH0) = Timing Duty
					// When Fosc = 11.0592MHz and TH0 = 0x78,
					// Timing Duty is 0.125msec (124.7 usec)
		
	
	TF0 = 0;
	
	ET0 = 1;		// Timer 0 Interrupt Enable


	//----------------------------------------------------
	SM0 = 0;		// SM0,SM1 = [0,1] : UART Mode 1 (8-bit UART)
	SM1 = 1;
	
	//CKCON |= 0x10;	// T1M = 1;
		
	TH1   = 0xFD;	// Refer to the UART table at Brief Manual of MiDAS1.0 Family.
		
	REN	  = 1;		// Reception Enable 
	
	TF1   = 0;		  
	
	PS    = 1;		// UART Priority Enable
	
	ES    = 1;		// UART Interrupt (Commnucation) Enable	
	
	
	//-------------------------------------------------
	ADCSEL |= 0x08;		// ADC Channel Port Selection : P1.3
	
	ADCON |= AD_EN_;		// ADC Enable (AD_EN_ or 0x80)
	
	ADCON |= 0x0c;		// ADC Channel Analog MUX Selection : P1.3

	PADC = 1;	
	EADC = 1;			// ADC Interrupt Enable	
	
	//-------------------------------------------------
	EA =  1;			// All Interrupts Enable
	
	
	//-------------------------------------------------
	loop_cnt = 0;
	hund = '0';
	ten  = '0';
	one  = '0';
	adc_result = 0;
	

} // End: void initialize(void)

// Sub Function : Timer 0 Interrupt
void timer0_int(void) interrupt TF0_VECTOR {
	
	// 7-segment Display	
	if (loop_cnt == 4000) {	 // 4000 : 0.5sec

		loop_cnt = 0;
		
		ADCON |= AD_REQ_;		// ADC Run/Start (AD_REQ_ or 0x40)
	}
	
	loop_cnt++;
	TF0 = 0;					 // Timer 0 Overflow Falg Clear

} // End : Sub Function - void timer0_int(void) interrupt TF0_VECTOR


// Sub Function : ADC Interrupt
void adc_int(void) interrupt ADC_VECTOR {
	
	// LED Display
	pcode = (unsigned char xdata *)0xFD00;		// Port C (LED Display)
	*(pcode) = ADCR;							// ADC Result (Upper 8 bits)
												// ADC Result (9 bits) = ADCR (upper 8 bits), ADCON.0(1 bit)
				
	// ADC Result --> ASCII
	adc_result = ADCR;				// ADCR : SAR[8:1]
	adc_result *= 2;				// Left Shift
	adc_result |= (ADCON & 0x01);	// ADCON.0 : SAR0


	// ASCII Code Conversion
			
										
	// LCD Display
	
	
	
	// UART
	SBUF = '_';
	SBUF = hund;
	SBUF = ten;
	SBUF = one;
												
	ADCON &= 0xEF;				// ADC Interrupt Falg (ADCF) Clear
	
}


// Sub Function : UART Interrupt (Serial Communication)
void uart_int(void) interrupt SIO_VECTOR {

	while (1) {
	
		if (TI) {				// Transmit Mode
			TI = 0;
			break;
			
		} else if (RI) {		// Receive Mode
			received_data = SBUF;
			RI = 0;
			break;		
		}
	}
	
}
