// File Name : main.c
// Programmed by Hyun Jee
// Program Date : Mon., Jan. 10, 2005

#include <GC80C520_PL44I.H>
#include "timer.h"

// Declaration of the Variables
xdata unsigned char *pcode;				  // for External Memory
data unsigned char  temp1;				  // for Temporary Data
data unsigned char  temp;				  
data unsigned char  i;					  // for Loop Parameters
data unsigned char  p;					  // for Loop Parameters
data unsigned char	port_change;		  // for PORT Display Delection
data unsigned char	port_value_change;	  // for PORT Value Update Change
data unsigned char	port_display_change;  // for PORT Display Selection

unsigned int	loop_cnt;			// for Loop Parameter    @ timer0
unsigned char	received_data;

unsigned char	hund;
unsigned char	ten;
unsigned char	one;
unsigned char	num;
unsigned char	poly, temp2;

unsigned char	snum[3];
unsigned int	snum_cnt;

unsigned int	adc_result;

// Prototype Functions

// 1. System Initialization
void initialize(void);

// 2. LCD Initialization
void initialize_lcd(void);

// 3. Clear LCD Screen
void clearscreen_lcd(void); 

// 4. LCD Address Setting
void address_lcd(unsigned char);

// 5. Print a Character on the LCD Screen
void print_char_lcd(unsigned char);

// 6. Print a String on the LCD Screen
void print_string_lcd(void);

// 7. msec fuction
void msec (int);

// 8. delay fuction
void delay_lcd (unsigned int);

// 9. Display Character
void PutChar (unsigned char);

//10. Switch
void SwitchAsc (unsigned char);

//************************ Main Function *************************//
void main(void) {

	delay_lcd(225);	
	delay_lcd(225);	
	delay_lcd(225);	
	

	initialize();
	
	initialize_lcd();

	clearscreen_lcd();
	
	loop_cnt = 0;

	TR1 = 1;	// Timer1 Start (Enable) for UART Communication
	TR0 = 1;	// Timer0 Start (Enable) 

	while(1){
		temp = 0;
	}	
} // End: void Main(void)
//****************************************************************//



// Sub Function - 1. void initialize(void)
void initialize(void) {
	//-------------------------------------------------
	TMOD  = 0x22; 	// Timer 0/1 : Mode 2<Auto Reload>
	    
	TH0   = 0x78;   // TH0 for Auto-reload
					// (Fosc/11.0592MHz)^-1*(256-TH0) = Timing Duty
					// When Fosc = 11.0592MHz and TH0 = 0x78,
					// Timing Duty is 0.125msec (124.7 usec)	
	TF0 = 0;
	
	ET0 = 1;		// Timer 0 Interrupt Enable

	//----------------------------------------------------
	SM0 = 0;		// SM0,SM1 = [0,1] : UART Mode 1 (8-bit UART)
	SM1 = 1;
	
	TH1   = 0xFD;	// Refer to the UART table at Brief Manual of MiDAS1.0 Family.
		
	REN	  = 1;		// Reception Enable 
	
	TF1   = 0;		  
	
//	PS    = 1;		// UART Priority Enable
	IPH	|= 0x10;	// PSH,PS = 1,0
	
	ES    = 1;		// UART Interrupt (Commnucation) Enable		
	
	//-------------------------------------------------
//	ADCSEL |= 0x08;		// ADC Channel Port Selection : P1.3
	
//	ADCON |= AD_EN_;		// ADC Enable (AD_EN_ or 0x80)
	
//	ADCON |= 0x0c;		// ADC Channel Analog MUX Selection : P1.3

//	PADC = 1;	
//	EADC = 1;			// ADC Interrupt Enable	
	
	//-------------------------------------------------
	EA =  1;			// All Interrupts Enable	
	
	//-------------------------------------------------
	//pcode = (unsigned char xdata *)0x0000;
	loop_cnt = 0;
	snum_cnt = 0;

	hund = '0';
	ten  = '0';
	one  = '0';
	adc_result = 0;
	
	for (i=0; i<3; i++) {
		snum[i] = '0';
	}
} // End: void initialize(void)

// Sub Function - 2. void initialize_lcd(void)
void initialize_lcd(void) {
	// pcode = 0xFFXX : PORTA (and Character LCD Display Databus)
	// pcode = 0xF9XX : LCD_CON[0] (LCD_RW)
	// pcode = 0xF8XX : LCD_CON[1] (LCD_EN)
	// pcode = 0xF7XX : LCD_CON[2] (LCD_RS)

	pcode =(unsigned char xdata *)0xF200;
	*(pcode) = 0x00;		// LCD_RW = 0;
	pcode = (unsigned char xdata *)0xF100;
	*(pcode) = 0x00;		// LCD_EN = 0;
	pcode = (unsigned char xdata *)0xF000;
	*(pcode) = 0x00;		// LCD_RS = 0;

	msec(50);

	pcode = (unsigned char xdata *)0xF300;
	*(pcode) = FUNCTION_SET2;
	pcode = (unsigned char xdata *)0xF100;
	*(pcode) = 0x01;		// LCD_EN = 1;
	*(pcode) = 0x00;		// LCD_EN = 0;

	delay_lcd(45);
	delay_lcd(45);

	pcode = (unsigned char xdata *)0xF300;
	*(pcode) = DISPLAY_ON1;
	pcode = (unsigned char xdata *)0xF100;
	*(pcode) = 0x01;		// LCD_EN = 1;
	*(pcode) = 0x00;		// LCD_EN = 0;
	
	delay_lcd(255);
	delay_lcd(225);
	delay_lcd(225);

	pcode = (unsigned char xdata *)0xF300;
	*(pcode) = CLEAR_DISPLAY;
	pcode = (unsigned char xdata *)0xF100;
	*(pcode) = 0x01;		// LCD_EN = 1;
	*(pcode) = 0x00;		// LCD_EN = 0;
	
	delay_lcd(255);
	delay_lcd(225);
	delay_lcd(225);

	pcode = (unsigned char xdata *)0xF300;
	*(pcode) = ENTRY_MODE1;
	pcode = (unsigned char xdata *)0xF100;
	*(pcode) = 0x01;		// LCD_EN = 1;
	*(pcode) = 0x00;		// LCD_EN = 0;

	delay_lcd(255);
	delay_lcd(225);
	delay_lcd(225);

	pcode = (unsigned char xdata *)0xF000;
	*(pcode) = 0x01;		// LCD_RS = 1;
	
	msec(50);

} // End: void initialize_lcd(void)

// Sub Function - 3. void clearscreen_lcd(void)
void clearscreen_lcd(void) {
	// pcode = 0xFFXX : PORTA (and Character LCD Display Databus)
	// pcode = 0xF9XX : LCD_CON[0] (LCD_RW)
	// pcode = 0xF8XX : LCD_CON[1] (LCD_EN)
	// pcode = 0xF7XX : LCD_CON[2] (LCD_RS)

	pcode =(unsigned char xdata *)0xF000;
	*(pcode) = 0x00;		// LCD_RS = 0;

	pcode = (unsigned char xdata *)0xF300;
	*(pcode) = CLEAR_DISPLAY;
	pcode = (unsigned char xdata *)0xF100;
	*(pcode) = 0x01;		// LCD_EN = 1;
	*(pcode) = 0x00;		// LCD_EN = 0;

	pcode = (unsigned char xdata *)0xF000;
	*(pcode) = 0x01;		// LCD_RS = 1;
	
	delay_lcd(255);	
} // End: void clearscreen_lcd(void)

// Sub Function - 4. void address_lcd(BYTE)
void address_lcd(unsigned char addr) {
	// pcode = 0xFFXX : PORTA (and Character LCD Display Databus)
	// pcode = 0xF9XX : LCD_CON[0] (LCD_RW)
	// pcode = 0xF8XX : LCD_CON[1] (LCD_EN)
	// pcode = 0xF7XX : LCD_CON[2] (LCD_RS)
	
	pcode = (unsigned char xdata *)0xF000;
	*(pcode) = 0x00;		// LCD_RS = 0;

	pcode = (unsigned char xdata *)0xF300;
	*(pcode) = addr;
	pcode = (unsigned char xdata *)0xF100;
	*(pcode) = 0x01;		// LCD_EN = 1;
	*(pcode) = 0x00;		// LCD_EN = 0;

	pcode = (unsigned char xdata *)0xF000;
	*(pcode) = 0x01;		// LCD_RS = 1;

	delay_lcd(255);
} // End: void address_lcd(BYTE addr) 

// Sub Function : 5. void print_char_lcd(BYTE)
void print_char_lcd(unsigned char c) {
	// pcode = 0xFFXX : PORTA (and Character LCD Display Databus)
	// pcode = 0xF9XX : LCD_CON[0] (LCD_RW)
	// pcode = 0xF8XX : LCD_CON[1] (LCD_EN)
	// pcode = 0xF7XX : LCD_CON[2] (LCD_RS)

	pcode = (unsigned char xdata *)0xF000;
	*(pcode) = 0x01;		// LCD_RS = 1;

	pcode = (unsigned char xdata *)0xF300;
	*(pcode) = c;
	pcode = (unsigned char xdata *)0xF100;
	*(pcode) = 0x01;		// LCD_EN = 1;
	*(pcode) = 0x00;		// LCD_EN = 0;

	pcode = (unsigned char xdata *)0xF000;
	*(pcode) = 0x00;		// LCD_RS = 0;
		
	delay_lcd(45);	
} // End: void print_char_lcd(BYTE c)

// Sub Function : 6. void print_string_lcd(const char *)
void print_string_lcd(void) {
	// pcode = 0xFFXX : PORTA (and Character LCD Display Databus)
	// pcode = 0xF9XX : LCD_CON[0] (LCD_RW)
	// pcode = 0xF8XX : LCD_CON[1] (LCD_EN)
	// pcode = 0xF7XX : LCD_CON[2] (LCD_RS)

	print_char_lcd(snum[0]);	// hund
	print_char_lcd(snum[1]);	// ten
	print_char_lcd(snum[2]);	// one	
	
	delay_lcd(225);	
} // End: void print_string_lcd(const char *s)

// Sub Function : 7. delay function for m seconds
void msec(int Delay)
{
	int i, j;
	for(j=0; j<Delay; j++)
		for (i=0; i<100; i++);		
}

// Sub Function : 8. delay function
void delay_lcd(unsigned int t)
{
	unsigned int i;
	for(i=0; i<t; i++);
}

// Sub Function : 9. Putchar
void PutChar(unsigned char c) {
	//RS=1;
	pcode = 0xF000;
	*(pcode) = 0x01;		// LCD_RS = 1;

	//LCD_BUS = c;
	pcode = 0xF300;
	*(pcode) = c;
 	//EnableLCD();
	pcode = 0xF100;
	*(pcode) = 0x01;		// LCD_EN = 1;
	*(pcode) = 0x00;		// LCD_EN = 0;
	//RS=0;
	pcode = 0xF000;
	*(pcode) = 0x00;		// LCD_RS = 0;
	delay_lcd(45);
}

// Sub Function : 10. Switch
void SwitchAsc (unsigned char ch){
	switch (ch ) {
		case 0 :
			temp = '0';
			break;
		case 1 :
			temp = '1';
			break;
		case 2 :
			temp = '2';
			break;
		case 3 :
			temp = '3';
			break;
		case 4 :
			temp = '4';
			break;
		case 5 :
			temp = '5';
			break;
		case 6 :
			temp = '6';
			break;
		case 7 :
			temp = '7';
			break;
		case 8 : 
			temp = '8';
			break;
		case 9 :
			temp = '9';
			break;
	}
	PutChar(temp);
	num = temp;
}

// Sub Function : Timer 0 Interrupt
void timer0_int(void) interrupt TF0_VECTOR {
	
	// 7-segment Display	
	if (loop_cnt == 4000) {	 // 4000 : 0.5sec

		loop_cnt = 0;
	}
	
	loop_cnt++;
	TF0 = 0;					 // Timer 0 Overflow Falg Clear

} // End : Sub Function - void timer0_int(void) interrupt TF0_VECTOR

// Sub Function : UART Interrupt (Serial Communication)
void uart_int(void) interrupt SIO_VECTOR {

	while (1) {
		if (TI) {				// Transmit Mode
			TI = 0;
			break;			
		} else if (RI) {		// Receive Mode
			received_data = SBUF;
			
			if (received_data =='_') {
				i = 0;
			} else {
				snum[i] = received_data;
				i++;
			}
			
			if (i==3) {
				address_lcd(0xc0);
				print_string_lcd();
				delay_lcd(200);
			}		
	
			RI = 0;
			break;		
		}
	}
}
